## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XalanDocumentType Class Reference

`#include <XalanDocumentType.hpp>`

Inheritance diagram for XalanDocumentType:

[legend]
Collaboration diagram for XalanDocumentType:

[legend]
List of all members.

## Public Methods

- XalanDocumentType ()
- virtual ~XalanDocumentType ()
- virtual const XalanDOMString& getNodeName () const=0
    Gets the name of this node. More...
- virtual const XalanDOMString& getNodeValue () const=0
    Gets the value of this node, depending on its type. More...
- virtual NodeType getNodeType () const=0
    An enum value representing the type of the underlying object. More...
- virtual XalanNode* getParentNode () const=0
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const=0
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const=0
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const=0
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const=0
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const=0
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const=0
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. More...
- virtual XalanDocument* getOwnerDocument () const=0
    Gets the `Document` object associated with this node. More...

Cloning function.

- virtual XalanNode* cloneNode (bool deep) const=0
    Returns a duplicate of this node. More...

Functions to modify the DOM Node.

- virtual XalanNode* insertBefore (XalanNode *newChild, XalanNode *refChild)=0
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild (XalanNode *newChild, XalanNode *oldChild)=0
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode *oldChild)=0
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode *newChild)=0
    Adds the node `newChild` to the end of the list of children of this node. More...

Query functions.

- virtual bool hasChildNodes () const=0
    This is a convenience method to allow easy determination of whether a node has any children. More...

Set functions.

- virtual void setNodeValue (const XalanDOMString &nodeValue)=0
    Sets the value of the node. More...

Functions introduced in DOM Level 2.

- virtual void normalize ()=0
    Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. More...
- virtual bool isSupported (const XalanDOMString &feature, const XalanDOMString &version) const=0
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const=0
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const=0
    Get the namespace prefix of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getLocalName () const=0
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString &prefix)=0
    Set the namespace prefix of this node. More...
- virtual bool isIndexed () const=0
    Determine if the document is node-order indexed. More...
- virtual IndexType getIndex () const=0
    Get the node's index. More...

Getter functions.

- virtual const XalanDOMString& getName () const=0
    The name of DTD; i.e., the name immediately following the `DOCTYPE` keyword in an XML source document. More...
- virtual const XalanNamedNodeMap* getEntities () const=0
    This function returns a `NamedNodeMap` containing the general entities, both external and internal, declared in the DTD. More...
- virtual const XalanNamedNodeMap* getNotations () const=0
    This function returns a named node map containing an entry for each notation declared in a document's DTD. More...

Functions introduced in DOM Level 2.

- virtual const XalanDOMString& getPublicId () const=0
    Get the public identifier of the external subset. More...
- virtual const XalanDOMString& getSystemId () const=0
    Get the system identifier of the external subset. More...
- virtual const XalanDOMString& getInternalSubset () const=0
    Get the internal subset as a string. More...

## Protected Methods

- XalanDocumentType (const XalanDocumentType &theSource)
- XalanDocumentType& operator= (const XalanDocumentType &theSource)
- bool operator== (const XalanDocumentType &theRHS) const

## Constructor & Destructor Documentation

XalanDocumentType::XalanDocumentType ( | )

XalanDocumentType::~XalanDocumentType ( | )`[virtual]`

XalanDocumentType::XalanDocumentType ( | const XalanDocumentType & theSource )`[protected]`

## Member Function Documentation

XalanNode * XalanDocumentType::appendChild ( | XalanNode * newChild )`[pure virtual]`

  | Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed. Parameters:
  newChild | The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
Returns: The node added. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::cloneNode ( | bool deep ) const`[pure virtual]`

  | Returns a duplicate of this node. This function serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null`.). Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node. Parameters:
  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
Returns: The duplicate node. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanNamedNodeMap * XalanDocumentType::getAttributes ( | ) const`[pure virtual]`

| Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanNodeList * XalanDocumentType::getChildNodes ( | ) const`[pure virtual]`

| Gets a `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanNamedNodeMap * XalanDocumentType::getEntities ( | ) const`[pure virtual]`

| This function returns a `NamedNodeMap` containing the general entities, both external and internal, declared in the DTD. Parameter entities are not contained. Duplicates are discarded. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::getFirstChild ( | ) const`[pure virtual]`

| Gets the first child of this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

IndexType XalanDocumentType::getIndex ( | ) const`[pure virtual]`

| Get the node's index. Valid only if the owner document reports that the document is node-order indexed. Returns: The index value, or 0 if the node is not indexed. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getInternalSubset ( | ) const`[pure virtual]`

| Get the internal subset as a string. Returns: The internal subset as a string. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::getLastChild ( | ) const`[pure virtual]`

| Gets the last child of this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getLocalName ( | ) const`[pure virtual]`

| Returns the local part of the qualified name of this node. For nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, it is null. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getName ( | ) const`[pure virtual]`

| The name of DTD; i.e., the name immediately following the `DOCTYPE` keyword in an XML source document. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getNamespaceURI ( | ) const`[pure virtual]`

| Get the namespace URI of this node, or `null` if it is unspecified. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time. For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::getNextSibling ( | ) const`[pure virtual]`

| Gets the node immediately following this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getNodeName ( | ) const`[pure virtual]`

| Gets the name of this node. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

NodeType XalanDocumentType::getNodeType ( | ) const`[pure virtual]`

| An enum value representing the type of the underlying object. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getNodeValue ( | ) const`[pure virtual]`

| Gets the value of this node, depending on its type. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanNamedNodeMap * XalanDocumentType::getNotations ( | ) const`[pure virtual]`

| This function returns a named node map containing an entry for each notation declared in a document's DTD. Duplicates are discarded. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanDocument * XalanDocumentType::getOwnerDocument ( | ) const`[pure virtual]`

| Gets the `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::getParentNode ( | ) const`[pure virtual]`

| Gets the parent of this node. All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` Node is returned. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getPrefix ( | ) const`[pure virtual]`

| Get the namespace prefix of this node, or `null` if it is unspecified. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::getPreviousSibling ( | ) const`[pure virtual]`

| Gets the node immediately preceding this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getPublicId ( | ) const`[pure virtual]`

| Get the public identifier of the external subset. Returns: The public identifier of the external subset. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

const XalanDOMString & XalanDocumentType::getSystemId ( | ) const`[pure virtual]`

| Get the system identifier of the external subset. Returns: The system identifier of the external subset. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

bool XalanDocumentType::hasChildNodes ( | ) const`[pure virtual]`

| This is a convenience method to allow easy determination of whether a node has any children. Returns: `true` if the node has any children, `false` if the node has no children. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[pure virtual]`

  | Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children. If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `Node` that has never been assigned to refer to an actual node is == null. Parameters:
  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.
Returns: The node being inserted. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

bool XalanDocumentType::isIndexed ( | ) const`[pure virtual]`

| Determine if the document is node-order indexed. Returns: true if the document is indexed, otherwise false. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

bool XalanDocumentType::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[pure virtual]`

  | Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. Parameters:
  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
Returns: Returns `true` if the specified feature is supported on this node, `false` otherwise. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

void XalanDocumentType::normalize ( | )`[pure virtual]`

| Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used. Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanDocumentType & XalanDocumentType::operator= ( | const XalanDocumentType & theSource )`[protected]`

bool XalanDocumentType::operator== ( | const XalanDocumentType & theRHS ) const`[protected]`

XalanNode * XalanDocumentType::removeChild ( | XalanNode * oldChild )`[pure virtual]`

  | Removes the child node indicated by `oldChild` from the list of children, and returns it. Parameters:
  oldChild | The node being removed.
Returns: The node removed. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

XalanNode * XalanDocumentType::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[pure virtual]`

  | Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed. Parameters:
  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.
Returns: The node replaced. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

void XalanDocumentType::setNodeValue ( | const XalanDOMString & nodeValue )`[pure virtual]`

| Sets the value of the node. Any node which can have a nodeValue ( See also: getNodeValue) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value. For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only. Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

void XalanDocumentType::setPrefix ( | const XalanDOMString & prefix )`[pure virtual]`

  | Set the namespace prefix of this node. Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable. Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change. Parameters:
  prefix | The prefix of this node.
  Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.
Reimplemented from XalanNode. Reimplemented in XercesDocumentTypeWrapper, and XercesDocumentTypeBridge.

The documentation for this class was generated from the following file:

- XalanDocumentType.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.